## qmenumodel 0.2.7+14.04.20140305

=== examples/CMakeLists.txt ===
# Standalone CMakeLists.txt to generate the info-menumodel executable.
# This is not built as part of libqmenumodel, it has to be built separately
# and it assumes libqmenumodel-dev is installed on the system.

cmake_minimum_required(VERSION 2.8.9)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

find_package(Qt5Core REQUIRED)

include(FindPkgConfig)
pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)

add_executable(info-menumodel info-menumodel.cpp)

qt5_use_modules(info-menumodel Core)
include_directories(${QMENUMODEL_INCLUDE_DIRS})
target_link_libraries(info-menumodel ${QMENUMODEL_LDFLAGS})

=== tests/client/CMakeLists.txt ===
macro(declare_test testname)
    add_executable(${testname} ${testname}.cpp)
    qt5_use_modules(${testname} Core DBus Widgets Test Qml Quick)
    target_link_libraries(${testname}
                          qmenumodel
                          dbusmenuscript
                          ${GLIB_LDFLAGS}
                          ${GIO_LDFLAGS}
    )

    if(TEST_XML_OUTPUT)
        set(TEST_ARGS -p -xunitxml -p -o -p test_${testname}.xml)
    else()
        set(TEST_ARGS "")
    endif()

    add_test(${testname}
             ${DBUS_RUNNER}
             --task ${CMAKE_CURRENT_BINARY_DIR}/${testname} ${TEST_ARGS} --task-name Client
             --task ${CMAKE_CURRENT_SOURCE_DIR}/script_${testname}.py --task-name Server
             --ignore-return)
    set_tests_properties(${testname} PROPERTIES
                         TIMEOUT ${CTEST_TESTING_TIMEOUT}
                         ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};QT_QPA_PLATFORM=minimal")

endmacro(declare_test testname)

macro(declare_simple_test testname)
    add_executable(${testname} ${testname}.cpp)
    qt5_use_modules(${testname} Core Test)
    target_link_libraries(${testname}
                          qmenumodel
                          ${GLIB_LDFLAGS}
                          ${GIO_LDFLAGS}
    )

    add_test(${testname}
             ${CMAKE_CURRENT_BINARY_DIR}/${testname})

    set_tests_properties(${testname} PROPERTIES
                         TIMEOUT ${CTEST_TESTING_TIMEOUT})
endmacro(declare_simple_test testname)

include_directories(${src_SOURCE_DIR}
                    ${dbusmenuscript_SOURCE_DIR}
                    ${GLIB_INCLUDE_DIRS}
)

add_definitions(-DTEST_SUITE)
set(TEST_PYTHONPATH ${dbusmenuscript_SOURCE_DIR})
if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

declare_test(servicetest)
declare_test(menuchangestest)
declare_test(modeltest)
declare_test(actiongrouptest)
declare_test(qmltest)
declare_test(convertertest)
declare_test(modelsignalstest)
declare_test(treetest)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmlfiles.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/qmlfiles.h)

## qmenumodel 0.2.9+16.04.20160329

=== CMakeLists.txt ===
project(qmenumodel)

cmake_minimum_required(VERSION 2.8.9)

# Standard install paths
include(GNUInstallDirs)

find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Gui REQUIRED)
include(FindPkgConfig)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_definitions(-DQT_NO_KEYWORDS)

find_program(DBUS_RUNNER dbus-test-runner)

# Cooverage tools
OPTION(ENABLE_COVERAGE "Build with coverage analysis support" OFF)
if(ENABLE_COVERAGE)
    message(STATUS "Using coverage flags")
    find_program(COVERAGE_COMMAND gcov)
    if(NOT COVERAGE_COMMAND)
        message(FATAL_ERROR "gcov command not found")
    endif()
    SET(CMAKE_C_FLAGS "-g -O0 -Wall --coverage")
    SET(CMAKE_CXX_FLAGS "-g -O0 -Wall --coverage")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
    include(${CMAKE_SOURCE_DIR}/cmake/lcov.cmake)
endif()

add_subdirectory(libqmenumodel)

# Tests Tools
OPTION(TEST_XML_OUTPUT "Print test results on xml files" ON)
if(NOT DBUS_RUNNER)
    message(STATUS "dbus-test-runner not found tests disabled.")
else()
    # We need to enable test to create the 'make check' target mandatory on jenkins
    enable_testing()
    if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7l")
        message(STATUS "Current version of qemu crashes during the tests. We will skip it for now.")
    else()
        message(STATUS "Tests enabled for arch: ${CMAKE_SYSTEM_PROCESSOR}")
        add_subdirectory(tests)
    endif()
endif()

# Doc
OPTION(GENERATE_DOC "Enable qdoc generation" OFF)
if(GENERATE_DOC)
    message(STATUS "QDoc enabled.")
    find_program(QDOC_BIN qdoc)
    if(NOT QDOC_BIN)
        message(FATAL_ERROR "qdoc command not found")
    else()
        add_subdirectory(doc)
    endif()
endif()

=== QMenuModel/CMakeLists.txt ===
project(qmlplugin)

set(QMLPLUGIN_SRC
    plugin.cpp
)

add_library(qmenumodel-qml MODULE
    ${QMLPLUGIN_SRC}
)

include_directories(
    ${src_SOURCE_DIR}
    ${GLIB_INCLUDE_DIRS}
)

target_link_libraries(qmenumodel-qml
    qmenumodel
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
)

qt5_use_modules(qmenumodel-qml Qml Quick)

execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/qmldir"
                                                              "${CMAKE_CURRENT_BINARY_DIR}/qmldir")

execute_process(
    COMMAND qmake -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_IMPORTS_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(QMLPLUGIN_INSTALL_PREFIX "${QT_IMPORTS_DIR}/QMenuModel")
install(TARGETS qmenumodel-qml DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})
install(FILES qmldir DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})

=== client/CMakeLists.txt ===
macro(declare_test testname)
    add_executable(${testname} ${testname}.cpp)
    qt5_use_modules(${testname} Core DBus Widgets Test Qml Quick)
    target_link_libraries(${testname}
                          qmenumodel
                          dbusmenuscript
                          ${GLIB_LDFLAGS}
                          ${GIO_LDFLAGS}
    )

    if(TEST_XML_OUTPUT)
        set(TEST_ARGS -p -xunitxml -p -o -p test_${testname}.xml)
    else()
        set(TEST_ARGS "")
    endif()

    add_test(${testname}
             ${DBUS_RUNNER}
             --task ${CMAKE_CURRENT_BINARY_DIR}/${testname} ${TEST_ARGS} --task-name Client
             --task ${CMAKE_CURRENT_SOURCE_DIR}/script_${testname}.py --task-name Server
             --ignore-return)
    set_tests_properties(${testname} PROPERTIES
                         TIMEOUT ${CTEST_TESTING_TIMEOUT}
                         ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};QT_QPA_PLATFORM=minimal")

endmacro(declare_test testname)

macro(declare_simple_test testname)
    add_executable(${testname} ${testname}.cpp)
    qt5_use_modules(${testname} Core Test)
    target_link_libraries(${testname}
                          qmenumodel
                          ${GLIB_LDFLAGS}
                          ${GIO_LDFLAGS}
    )

    add_test(${testname}
             ${CMAKE_CURRENT_BINARY_DIR}/${testname})

    set_tests_properties(${testname} PROPERTIES
                         TIMEOUT ${CTEST_TESTING_TIMEOUT})
endmacro(declare_simple_test testname)

include_directories(${src_SOURCE_DIR}
                    ${dbusmenuscript_SOURCE_DIR}
                    ${GLIB_INCLUDE_DIRS}
)

add_definitions(-DTEST_SUITE)
set(TEST_PYTHONPATH ${dbusmenuscript_SOURCE_DIR})
if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

declare_test(servicetest)
declare_test(menuchangestest)
declare_test(modeltest)
declare_test(actiongrouptest)
declare_test(qmltest)
declare_test(convertertest)
declare_test(modelsignalstest)
declare_test(treetest)
declare_test(unitymenuactiontest)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmlfiles.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/qmlfiles.h)

=== script/CMakeLists.txt ===
project(dbusmenuscript)

add_library(dbusmenuscript STATIC dbusmenuscript.cpp)

set_target_properties(dbusmenuscript PROPERTIES COMPILE_FLAGS -fPIC)

qt5_use_modules(dbusmenuscript Core DBus Test)

=== src/CMakeLists.txt ===
project(src)

set(QMENUMODEL_SRC
    actionstateparser.cpp
    converter.cpp
    dbus-enums.h
    menunode.cpp
    qmenumodel.cpp
    qdbusobject.cpp
    qdbusmenumodel.cpp
    qdbusactiongroup.cpp
    qmenumodelevents.cpp
    qstateaction.cpp
    unitymenuaction.cpp
    unitymenuactionevents.cpp
    unitymenumodel.cpp
    unitymenumodelevents.cpp
    gtk/gtkactionmuxer.c
    gtk/gtkactionmuxer.h
    gtk/gtkactionobservable.c
    gtk/gtkactionobservable.h
    gtk/gtkactionobserver.c
    gtk/gtkactionobserver.h
    gtk/gtksimpleactionobserver.c
    gtk/gtksimpleactionobserver.h
    gtk/gtkmenutracker.c
    gtk/gtkmenutracker.h
    gtk/gtkmenutrackeritem.c
    gtk/gtkmenutrackeritem.h
)

set(SHAREDLIBNAME qmenumodel)
add_library(${SHAREDLIBNAME} SHARED
    ${QMENUMODEL_SRC}
)

set_target_properties(${SHAREDLIBNAME} PROPERTIES
    COMPILE_FLAGS -fPIC
    SOVERSION 0
    VERSION 0.1.1
)

include_directories(
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
)

target_link_libraries(${SHAREDLIBNAME}
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
)

qt5_use_modules(${SHAREDLIBNAME} Core Qml Quick)

install(TARGETS ${SHAREDLIBNAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(QMENUMODEL_HEADERS
    actionstateparser.h
    dbus-enums.h
    qdbusactiongroup.h
    qdbusmenumodel.h
    qdbusobject.h
    qmenumodel.h
    qstateaction.h
    unitymenuaction.h
    unitymenumodel.h
)

set(INCLUDEDIR qmenumodel)
install(FILES ${QMENUMODEL_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${INCLUDEDIR}
)

set(PCFILE qmenumodel.pc)
configure_file(${PCFILE}.in ${CMAKE_CURRENT_BINARY_DIR}/${PCFILE} @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PCFILE}
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

## qmenumodel 0.2.10%2b17.04.20161116

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
+SET(CMAKE_CXX_FLAGS "-std=c++11")
 add_definitions(-DQT_NO_KEYWORDS)
 
 find_program(DBUS_RUNNER dbus-test-runner)
@@ -26,7 +27,7 @@
         message(FATAL_ERROR "gcov command not found")
     endif()
     SET(CMAKE_C_FLAGS "-g -O0 -Wall --coverage")
-    SET(CMAKE_CXX_FLAGS "-g -O0 -Wall --coverage")
+    SET(CMAKE_CXX_FLAGS "-g -O0 -Wall -std=c++11 --coverage")
     SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
     include(${CMAKE_SOURCE_DIR}/cmake/lcov.cmake)
 endif()

=== QMenuModel/CMakeLists.txt ===
--- 
+++ 
@@ -24,11 +24,7 @@
 execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/qmldir"
                                                               "${CMAKE_CURRENT_BINARY_DIR}/qmldir")
 
-execute_process(
-    COMMAND qmake -query QT_INSTALL_QML
-    OUTPUT_VARIABLE QT_IMPORTS_DIR
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-)
+set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
 set(QMLPLUGIN_INSTALL_PREFIX "${QT_IMPORTS_DIR}/QMenuModel")
 install(TARGETS qmenumodel-qml DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})
 install(FILES qmldir DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})

## qmenumodel 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 project(qmenumodel)
+
+set (PROJECT_VERSION "0.8.0")
 
 cmake_minimum_required(VERSION 2.8.9)
 
@@ -17,20 +19,6 @@
 add_definitions(-DQT_NO_KEYWORDS)
 
 find_program(DBUS_RUNNER dbus-test-runner)
-
-# Cooverage tools
-OPTION(ENABLE_COVERAGE "Build with coverage analysis support" OFF)
-if(ENABLE_COVERAGE)
-    message(STATUS "Using coverage flags")
-    find_program(COVERAGE_COMMAND gcov)
-    if(NOT COVERAGE_COMMAND)
-        message(FATAL_ERROR "gcov command not found")
-    endif()
-    SET(CMAKE_C_FLAGS "-g -O0 -Wall --coverage")
-    SET(CMAKE_CXX_FLAGS "-g -O0 -Wall -std=c++11 --coverage")
-    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
-    include(${CMAKE_SOURCE_DIR}/cmake/lcov.cmake)
-endif()
 
 add_subdirectory(libqmenumodel)
 
@@ -61,3 +49,13 @@
     endif()
 endif()
 
+# Coverage
+#####################################################################
+# Enable code coverage calculation with gcov/gcovr/lcov
+# Usage:
+#  * Switch build type to coverage (use ccmake or cmake-gui)
+#  * Invoke make, make test, make coverage (or ninja if you use that backend)
+#  * Find html report in subdir coveragereport
+#  * Find xml report feasible for jenkins in coverage.xml
+#####################################################################
+find_package(CoverageReport)

=== libqmenumodel/QMenuModel/CMakeLists.txt ===
project(qmlplugin)

set(QMLPLUGIN_SRC
    plugin.cpp
)

add_library(qmenumodel-qml MODULE
    ${QMLPLUGIN_SRC}
)

include_directories(
    ${src_SOURCE_DIR}
    ${GLIB_INCLUDE_DIRS}
)

find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
target_link_libraries(qmenumodel-qml
    qmenumodel
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    Qt5::Qml Qt5::Quick
)

execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/qmldir"
                                                              "${CMAKE_CURRENT_BINARY_DIR}/qmldir")

set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(QMLPLUGIN_INSTALL_PREFIX "${QT_IMPORTS_DIR}/QMenuModel")
install(TARGETS qmenumodel-qml DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})
install(FILES qmldir DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})

=== libqmenumodel/src/CMakeLists.txt ===
project(src)

set(QMENUMODEL_SRC
    actionstateparser.cpp
    converter.cpp
    dbus-enums.h
    menunode.cpp
    qmenumodel.cpp
    qdbusobject.cpp
    qdbusmenumodel.cpp
    qdbusactiongroup.cpp
    qmenumodelevents.cpp
    qstateaction.cpp
    unitymenuaction.cpp
    unitymenuactionevents.cpp
    unitymenumodel.cpp
    unitymenumodelevents.cpp
    gtk/gtkactionmuxer.c
    gtk/gtkactionmuxer.h
    gtk/gtkactionobservable.c
    gtk/gtkactionobservable.h
    gtk/gtkactionobserver.c
    gtk/gtkactionobserver.h
    gtk/gtksimpleactionobserver.c
    gtk/gtksimpleactionobserver.h
    gtk/gtkmenutracker.c
    gtk/gtkmenutracker.h
    gtk/gtkmenutrackeritem.c
    gtk/gtkmenutrackeritem.h
)

set(SHAREDLIBNAME qmenumodel)
add_library(${SHAREDLIBNAME} SHARED
    ${QMENUMODEL_SRC}
)

set_target_properties(${SHAREDLIBNAME} PROPERTIES
    COMPILE_FLAGS -fPIC
    SOVERSION 0
    VERSION 0.1.1
)

include_directories(
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
)

find_package(Qt5Quick REQUIRED)
target_link_libraries(${SHAREDLIBNAME}
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    Qt5::Core Qt5::Qml Qt5::Quick
)

install(TARGETS ${SHAREDLIBNAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(QMENUMODEL_HEADERS
    actionstateparser.h
    dbus-enums.h
    qdbusactiongroup.h
    qdbusmenumodel.h
    qdbusobject.h
    qmenumodel.h
    qstateaction.h
    unitymenuaction.h
    unitymenumodel.h
)

set(INCLUDEDIR qmenumodel)
install(FILES ${QMENUMODEL_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${INCLUDEDIR}
)

set(PCFILE qmenumodel.pc)
configure_file(${PCFILE}.in ${CMAKE_CURRENT_BINARY_DIR}/${PCFILE} @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PCFILE}
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== tests/client/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
                          TIMEOUT ${CTEST_TESTING_TIMEOUT}
                          ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};QT_QPA_PLATFORM=minimal")
 
+    set(TESTS ${TESTS} ${testname})
 endmacro(declare_test testname)
 
 macro(declare_simple_test testname)
@@ -60,6 +61,18 @@
 declare_test(convertertest)
 declare_test(modelsignalstest)
 declare_test(treetest)
+declare_test(unitymenuactiontest)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmlfiles.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/qmlfiles.h)
+
+find_package(CoverageReport)
+enable_coverage_report(
+  TARGETS
+    qmenumodel
+  FILTER
+    ${CMAKE_SOURCE_DIR}/tests/*
+    ${CMAKE_BINARY_DIR}/*
+  TESTS
+    ${TESTS}
+)

=== debian/changelog ===
qmenumodel (0.8.0-2) unstable; urgency=medium

  * Source-only upload as is.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 22 Oct 2020 10:07:41 +0200

qmenumodel (0.8.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #968602).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 18 Aug 2020 15:12:55 +0200

=== debian/control ===
Source: qmenumodel
Section: libs
Priority: optional
Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
Uploaders:
 Debian UBports Team <team+ubports@tracker.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 2.8.9),
               cmake-extras,
               libglib2.0-dev,
               qt5-qmake,
               qtbase5-dev (>= 5.0),
               qtdeclarative5-dev (>= 5.0),
               python3:any,
               python3-dbus:native,
               python3-gi:native,
               gir1.2-glib-2.0,
               dbus-test-runner,
               libgles2-mesa-dev | libgl-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/AyatanaIndicators/qmenumodel
Vcs-Git: https://salsa.debian.org/debian-ayatana-team/qmenumodel.git
Vcs-Browser: https://salsa.debian.org/debian-ayatana-team/qmenumodel/

Package: libqmenumodel0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: Qt binding for GMenuModel - shared library
 Qt binding for GMenuModel that allows connecting to a menu model exposed on
 D-Bus and presents it as a list model. It can be used to expose indicator or
 application menus for applications using the Qt framework.
 .
 This package contains the shared library required by applications using
 QMenuModel.

Package: libqmenumodel-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqmenumodel0 (= ${binary:Version}),
Description: Qt binding for GMenuModel - development files
 Qt binding for GMenuModel that allows connecting to a menu model exposed on
 D-Bus and presents it as a list model. It can be used to expose indicator or
 application menus for applications using the Qt framework.
 .
 This package contains the development headers for libqmenumodel.

Package: qmenumodel-qml
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqmenumodel0 (= ${binary:Version}),
Description: Qt binding for GMenuModel - QML module
 Qt binding for GMenuModel that allows connecting to a menu model exposed on
 D-Bus and presents it as a list model. It can be used to expose indicator or
 application menus for applications using the Qt framework.
 .
 This package contains the QML module for building applications using the
 QMenuModel library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_makeshlibs:
	dh_makeshlibs -Xlibqmenumodel-qml.so

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
https://releases.ayatana-indicators.org/source/qmenumodel/qmenumodel-(.+)\.tar\.gz

## qmenumodel 0.9.1

=== CMakeLists.txt ===
project(qmenumodel)
cmake_minimum_required(VERSION 3.13)
set (PROJECT_VERSION "0.9.1")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Options
option(ENABLE_TESTS "Enable all tests and checks" OFF)
option(ENABLE_COVERAGE "Enable coverage reports (includes enabling all tests and checks)" OFF)
option(ENABLE_WERROR "Treat all build warnings as errors" OFF)
option(TEST_XML_OUTPUT "Print test results to xml files" OFF)
option(GENERATE_DOC "Enable qdoc generation" OFF)

if(ENABLE_COVERAGE)
    set(ENABLE_TESTS ON)
    set(CMAKE_BUILD_TYPE "Coverage")
else()
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(ENABLE_TESTS)
    set(TEST_XML_OUTPUT ON)
endif()

if(ENABLE_WERROR)
    add_definitions("-Werror")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_definitions("-Weverything")
else()
    add_definitions("-Wall")
endif()

# Standard install paths
include(GNUInstallDirs)
find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Gui REQUIRED)
include(FindPkgConfig)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_definitions(-DQT_NO_KEYWORDS)
add_subdirectory(libqmenumodel)

# Tests
if (ENABLE_TESTS)
    find_program(DBUS_RUNNER dbus-test-runner REQUIRED)
    enable_testing()
    if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7l")
        message(STATUS "Current version of qemu crashes during the tests. We will skip it for now.")
        set(ENABLE_TESTS OFF)
        set(ENABLE_COVERAGE OFF)
        set(TEST_XML_OUTPUT OFF)
    else()
        add_subdirectory(tests)
        if (ENABLE_COVERAGE)
            find_package(CoverageReport)
        endif()
    endif()
endif()

# Doc
if(GENERATE_DOC)
    find_program(QDOC_BIN qdoc REQUIRED)
    add_subdirectory(doc)
endif()

# Display config info
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Unit tests: ${ENABLE_TESTS}")
message(STATUS "Build with -Werror: ${ENABLE_WERROR}")
message(STATUS "Print test results to xml files: ${TEST_XML_OUTPUT}")
message(STATUS "QDoc generation: ${GENERATE_DOC}")

=== doc/CMakeLists.txt ===
set(QMENUMODEL_DOC_FILE ${CMAKE_CURRENT_BINARY_DIR}/qmenumodel.qdocconf)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/qmenumodel.qdocconf.in"
               ${QMENUMODEL_DOC_FILE} @ONLY)

add_custom_target(qdoc)
add_custom_command(TARGET qdoc
                   COMMAND ${QDOC_BIN} ${QMENUMODEL_DOC_FILE}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                   COMMENT "QDoc running...")

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,6 @@
 
 add_executable(info-menumodel info-menumodel.cpp)
 
-qt5_use_modules(info-menumodel Core)
 include_directories(${QMENUMODEL_INCLUDE_DIRS})
-target_link_libraries(info-menumodel ${QMENUMODEL_LDFLAGS})
+target_link_libraries(info-menumodel ${QMENUMODEL_LDFLAGS} Qt5::Core)

=== tests/CMakeLists.txt ===
find_package(Qt5Quick REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)

add_subdirectory(script)
add_subdirectory(client)

=== tests/client/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,16 @@
 macro(declare_test testname)
     add_executable(${testname} ${testname}.cpp)
-    qt5_use_modules(${testname} Core DBus Widgets Test Qml Quick)
     target_link_libraries(${testname}
                           qmenumodel
                           dbusmenuscript
                           ${GLIB_LDFLAGS}
                           ${GIO_LDFLAGS}
+                          Qt5::Core
+                          Qt5::DBus
+                          Qt5::Widgets
+                          Qt5::Test
+                          Qt5::Qml
+                          Qt5::Quick
     )
 
     if(TEST_XML_OUTPUT)
@@ -28,11 +33,12 @@
 
 macro(declare_simple_test testname)
     add_executable(${testname} ${testname}.cpp)
-    qt5_use_modules(${testname} Core Test)
     target_link_libraries(${testname}
                           qmenumodel
                           ${GLIB_LDFLAGS}
                           ${GIO_LDFLAGS}
+                          Qt5::Core
+                          Qt5::Test
     )
 
     add_test(${testname}
@@ -61,7 +67,7 @@
 declare_test(convertertest)
 declare_test(modelsignalstest)
 declare_test(treetest)
-declare_test(unitymenuactiontest)
+declare_test(ayatanamenuactiontest)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmlfiles.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/qmlfiles.h)

=== tests/script/CMakeLists.txt ===
project(dbusmenuscript)

add_library(dbusmenuscript STATIC dbusmenuscript.cpp)

set_target_properties(dbusmenuscript PROPERTIES COMPILE_FLAGS -fPIC)

target_link_libraries(dbusmenuscript Qt5::Core Qt5::DBus Qt5::Test)

=== debian/changelog ===
qmenumodel (0.9.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in template file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Feb 2022 21:40:32 +0100

qmenumodel (0.9.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/upstream/metadata:
    + Update points of contact, put UBports Foundation in Donation: field.
  * debian/{control,*.install}:
    + SOVERSION bump and QML API version bump.
  * debian/copyright:
    + Update copyright.in reference template.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 15 Dec 2021 23:11:42 +0100

qmenumodel (0.8.1-1) unstable; urgency=medium

  * New upstream release.
    - Move GLib-2.0 includes outside of extern "C". (Closes: #992363).
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/rules:
    + Enable unit tests.
  * debian/copyright:
    + Update copyright attributions.
  * debian/watch: Bump format version to 4.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 24 Oct 2021 16:35:05 +0200

=== debian/control ===
--- 
+++ 
@@ -18,13 +18,13 @@
                gir1.2-glib-2.0,
                dbus-test-runner,
                libgles2-mesa-dev | libgl-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/AyatanaIndicators/qmenumodel
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/qmenumodel.git
 Vcs-Browser: https://salsa.debian.org/debian-ayatana-team/qmenumodel/
 
-Package: libqmenumodel0
+Package: libqmenumodel1
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
@@ -42,7 +42,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libqmenumodel0 (= ${binary:Version}),
+         libqmenumodel1 (= ${binary:Version}),
 Description: Qt binding for GMenuModel - development files
  Qt binding for GMenuModel that allows connecting to a menu model exposed on
  D-Bus and presents it as a list model. It can be used to expose indicator or
@@ -50,11 +50,11 @@
  .
  This package contains the development headers for libqmenumodel.
 
-Package: qmenumodel-qml
+Package: qml-module-qmenumodel1
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libqmenumodel0 (= ${binary:Version}),
+         libqmenumodel1 (= ${binary:Version}),
 Description: Qt binding for GMenuModel - QML module
  Qt binding for GMenuModel that allows connecting to a menu model exposed on
  D-Bus and presents it as a list model. It can be used to expose indicator or
@@ -62,3 +62,17 @@
  .
  This package contains the QML module for building applications using the
  QMenuModel library.
+
+# remove for bookworm+1
+Package: qmenumodel-qml
+Section: oldlibs
+Architecture: any
+Depends: ${misc:Depends},
+         qml-module-qmenumodel1 (= ${binary:Version}),
+Description: Qt binding for GMenuModel - QML module (transitional package)
+ Qt binding for GMenuModel that allows connecting to a menu model exposed on
+ D-Bus and presents it as a list model. It can be used to expose indicator or
+ application menus for applications using the Qt framework.
+ .
+ This package facilitates the transition from qmenumodel-qml to
+ qml-module-qmenumodel.

## qmenumodel 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
-project(qmenumodel)
-cmake_minimum_required(VERSION 3.13)
-set (PROJECT_VERSION "0.9.1")
+cmake_minimum_required (VERSION 3.13)
+project (qmenumodel VERSION 0.9.2)
 
 if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
     SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
@@ -58,9 +57,6 @@
         set(TEST_XML_OUTPUT OFF)
     else()
         add_subdirectory(tests)
-        if (ENABLE_COVERAGE)
-            find_package(CoverageReport)
-        endif()
     endif()
 endif()

=== libqmenumodel/QMenuModel/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
                                                               "${CMAKE_CURRENT_BINARY_DIR}/qmldir")
 
 set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
-set(QMLPLUGIN_INSTALL_PREFIX "${QT_IMPORTS_DIR}/QMenuModel")
+set(QMLPLUGIN_INSTALL_PREFIX "${QT_IMPORTS_DIR}/QMenuModel.1")
 install(TARGETS qmenumodel-qml DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})
 install(FILES qmldir DESTINATION ${QMLPLUGIN_INSTALL_PREFIX})

=== libqmenumodel/src/CMakeLists.txt ===
--- 
+++ 
@@ -11,10 +11,10 @@
     qdbusactiongroup.cpp
     qmenumodelevents.cpp
     qstateaction.cpp
-    unitymenuaction.cpp
-    unitymenuactionevents.cpp
-    unitymenumodel.cpp
-    unitymenumodelevents.cpp
+    ayatanamenuaction.cpp
+    ayatanamenuactionevents.cpp
+    ayatanamenumodel.cpp
+    ayatanamenumodelevents.cpp
     gtk/gtkactionmuxer.c
     gtk/gtkactionmuxer.h
     gtk/gtkactionobservable.c
@@ -36,8 +36,8 @@
 
 set_target_properties(${SHAREDLIBNAME} PROPERTIES
     COMPILE_FLAGS -fPIC
-    SOVERSION 0
-    VERSION 0.1.1
+    SOVERSION 1
+    VERSION 1.0.0
 )
 
 include_directories(
@@ -62,8 +62,8 @@
     qdbusobject.h
     qmenumodel.h
     qstateaction.h
-    unitymenuaction.h
-    unitymenumodel.h
+    ayatanamenuaction.h
+    ayatanamenumodel.h
 )
 
 set(INCLUDEDIR qmenumodel)

=== tests/client/CMakeLists.txt ===
--- 
+++ 
@@ -72,13 +72,15 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmlfiles.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/qmlfiles.h)
 
-find_package(CoverageReport)
-enable_coverage_report(
-  TARGETS
-    qmenumodel
-  FILTER
-    ${CMAKE_SOURCE_DIR}/tests/*
-    ${CMAKE_BINARY_DIR}/*
-  TESTS
-    ${TESTS}
-)
+if (ENABLE_COVERAGE)
+    find_package(CoverageReport)
+    ENABLE_COVERAGE_REPORT(
+      TARGETS
+        qmenumodel
+      FILTER
+        ${CMAKE_SOURCE_DIR}/tests/*
+        ${CMAKE_BINARY_DIR}/*
+      TESTS
+        ${TESTS}
+    )
+endif()

=== debian/changelog ===
qmenumodel (0.9.2-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Increase the test timeout, thanks to Aurelien Jarno.
    (Closes: #1086635)

 -- Adrian Bunk <bunk@debian.org>  Wed, 09 Apr 2025 13:09:11 +0300

qmenumodel (0.9.2-1) unstable; urgency=medium

  [ Ratchanan Srirattanamet ]
  * debian: add .gitattributes to aid with changelog merging
  * debian/control: B-D on qml-module-qtquick2 (for a test)

  [ Mike Gabriel ]
  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update copyright attribution for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 24 Aug 2023 17:55:59 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                cmake (>= 2.8.9),
                cmake-extras,
                libglib2.0-dev,
+               qml-module-qtquick2 <!nocheck>,
                qt5-qmake,
                qtbase5-dev (>= 5.0),
                qtdeclarative5-dev (>= 5.0),
@@ -18,7 +19,7 @@
                gir1.2-glib-2.0,
                dbus-test-runner,
                libgles2-mesa-dev | libgl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/AyatanaIndicators/qmenumodel
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/qmenumodel.git

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,17 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
+DEB_CMAKE_EXTRA_FLAGS = \
+    -DCMAKE_INSTALL_LOCALSTATEDIR="/var" \
+    -DENABLE_TESTS=ON \
+    -DENABLE_COVERAGE=OFF \
+    $(NULL)
+
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)
 
 override_dh_makeshlibs:
 	dh_makeshlibs -Xlibqmenumodel-qml.so

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://releases.ayatana-indicators.org/source/qmenumodel/qmenumodel-(.+)\.tar\.gz
